
IF	Server_386_driver
;;;;.386
ELSE
.286
ENDIF

IF	0
;-------------------------------------------------------------------------
;   NIC_Mode
;	Change to NIC Mode, and save content of printer CMD port
;
;   Input:
;	Interrupt disable
;	ds		DGroup
;
;   Output:
;	save content of printer cmd port to Prn_Cmd
;	ax, dx		destroied
;-------------------------------------------------------------------------
NIC_Mode	proc	near
;;;Mode_NIC	   macro
;;;	   local   AlreadyNIC, NICFast, NIC_Endm

	cmp	_EBP ModeCount, 0
	jnz	AlreadyNIC			;already in NIC mode

	loadport
	setport CmdPort

	test	_EBP NICMode, FASTMODE
	jnz	NICFast

;---------------
; 6/14/1992 Andge Chen
;;	mov	al, _EBP NIC_Cmd
	mov	al, DS0+ICEN+IRQEN
	or	al, _EBP OutDirection
	mov	_EBP NIC_Cmd, al
;----------------

	out	dx, al				;change to NIC mode

	inc	_EBP ModeCount
;-----------
; 10/6/1992 Andge Chen		Old VeriData notebook must delay
	jmp	$+2
	jmp	$+2
	jmp	$+2
;-------
	ret
;jmp	 short NIC_Endm

NICFast:
;;;;	xor	al, al
	mov	al, ICEN+IRQEN
	or	al, _EBP OutDirection
	mov	_EBP NIC_Cmd, al
	out	dx, al

AlreadyNIC:
	inc	_EBP ModeCount
;	jmp	$+2
NIC_Endm:
	ret
NIC_Mode	endp
;;;	   endm



;-------------------------------------------------------------------------
;   PRN_Mode
;	Change to Printer Mode
;
;   Input:
;	ds		DGroup
;	interrupt disable
;
;   Output:
;	ax, dx		destroied
;-------------------------------------------------------------------------
Prn_Mode	proc	near
;;;Mode_Prn	   macro
;;;	   local   PM1, PM2, RemainNIC
	cmp	_EBP ModeCount, 0
	jz	RemainNIC

	dec	_EBP ModeCount
	jnz	RemainNIC

	test	_EBP NICMode, FASTMODE
	jnz	PM1
	loadport
	setport StatusPort
	RDYWait
	setport DataPort
	xor	al, al
	out	dx, al
	jmp	short PM2
PM1:
;;;;	    RDYWaitF
PM2:

;	dec	ModeCount
;	jnz	RemainNIC

	loadport
	setport CmdPort
;--------
; 10/6/1992 Andge Chen		the old veridata notebook problem
	mov	al, 01ch			;
;	mov	al, 018h			;Veridata can not use this value
;------------
	or	al, _EBP OutDirection

	out	dx, al				;change to NIC mode
	jmp	$+2
	jmp	$+2
RemainNIC:
	ret
Prn_Mode	endp
;;;	   endm
ENDIF


NIC_Mode	proc	near
	cmp	_EBP MPX_exist, 0
	je	MPX_Not_Exist
	loadport
	in	al, dx			;save data port value
	mov	ah, al
	setport CmdPort
	in	al, dx
	test	al, INITP
	jz	AlreadyDataMode

	mov	_EBP DataValueSave, ah

	and	al, AUTOFEED+STROBE
;;;	or	al, IRQEN+INITP
	or	al, INITP
	mov	_EBP CmdValueSave, al
	out	dx, al
	and	al, not INITP
	out	dx, al

	and	al, not AUTOFEED+STROBE
	test	_EBP NICMode, FASTMODE
	jnz	done_change
	or	al, STROBE
done_change:
	or	al, _EBP OutDirection
	mov	_EBP NIC_Cmd, al
	out	dx, al
AlreadyDataMode:
MPX_Not_Exist:
	ret
NIC_Mode	endp


Prn_Mode	proc	near
	cmp	_EBP MPX_exist, 0
	jz	No_MPX
	loadport
	mov	al, _EBP DataValueSave
	out	dx, al
	setport CmdPort
	mov	al, _EBP CmdValueSave
	and	al, not INITP
	out	dx, al
	or	al, INITP+IRQEN
	out	dx, al
No_MPX:
	ret
Prn_Mode	endp





;-------------------------------------------------------------------------
;   RemoteWrite
;	Remote Write data to Trasmit Buffer
;
;   Input
;	Already in Remote Write Period
;	Interrupt Disabled
;	ds		DGroup
;	es:si		Data buffer
;	cx		length of data
;
;   Output
;   Modified Register
;	ax, bx, cx, dx, si, di
;-------------------------------------------------------------------------
RemoteWrite	proc	near
	or	cx, cx
	jnz	RW4
	ret
RW4:
;;;;;	push	si

;	 cmp	 _EBP NICMode, FASTMODE
;	 jne	 RWCheckByte
;	 jmp	 RWFast
;RWCheckByte:
;	 cmp	 _EBP NICMode, BYTEMODE
;	 jne	 RWNibble
	cmp	_EBP NICMode, NIBBLEMODE
	je	RWNibble
RWCheckByte:
	cmp	_EBP NICMode, BYTEMODE
	je	RWByte
	jmp	RWFast

RWByte:
	loadport
;	setport Statusport
;	RDYWait
	mov	bh, _EBP NIC_Cmd
	setport CmdPort
	push	ds
	mov	ax, es
	mov	ds, ax
;----------------

OutByteL:
	sub	dx, 2				;data port
	outsb
	add	dx, 2				;cmd port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al
	loop	OutByteL
	pop	ds
	mov	_EBP NIC_Cmd, bh
	ret

RWNibble:
	mov	bh, _EBP NIC_Cmd
	loadport
	setport CmdPort
;	mov	bl, _EBP DelayCounter
;;;;;	push	di
	cmp	_EBP DFRRegister, 0
	jne	WaitNibble

	push	ds
	mov	ax, es
	mov	ds, ax
;----------------

OutByteLoop:
;	 dec	 dx				 ;status port
;	 xor	 di, di
;	 dec	 dx				 ;data port
sub	dx, 2
	outsb
	add	dx, 2				;cmd port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al
	loop	OutByteLoop
	pop	ds
	mov	_EBP NIC_Cmd, bh
RWRet:
;;;;;	pop	si
	ret

WaitNibble:
	push	ds
	mov	ax, es
	mov	ds, ax
;----------------

OutByteLoop1:
	dec	dx				;status port

;;;;;	RDYWait
;	 or	 bl, bl
;	 jz	 RWRDY2
;	 mov	 ah, bl
;RWRDY1:
;	 in	 al, 61h
;	 dec	 ah
;	 jnz	 RWRDY1
RWRDY2:
	xor	di, di
WaitLoop1:
	in	al, dx				;get status

	test	al, READY			;check RDY signal
	jnz	ReadyNow1
	dec	di
	jnz	WaitLoop1
ReadyNow1:
;--------

	dec	dx				;data port
	outsb
	add	dx, 2				;cmd port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al
	loop	OutByteLoop1
	pop	ds
	mov	_EBP NIC_Cmd, bh
	ret

RWFast:
	loadport
	setport DataStrobe0
	mov	bx, ds
	mov	ax, es
	mov	ds, ax
	test	si, 1
	jz	RW2
	outsb
IF	Server_386_driver
	dec	ecx
RW2:
	shr	ecx, 1
ELSE
	dec	cx
RW2:
	shr	cx, 1
ENDIF
	rep	outsw
	jnc	RW3
	outsb
RW3:
	mov	ds, bx
;;;;;	pop	si
	ret
RemoteWrite	endp




;-------------------------------------------------------------------------
;   RemoteRead
;	Remote Read data from receive buffer
;
;   Input
;	Already in Remote Read Period
;	Interrupt Disabled
;	ds		DGroup
;	es:di		Data buffer
;	cx		length of data
;
;   Output
;
;   Modified Register
;	dx, ax, bx, cx
;-------------------------------------------------------------------------
;GetRxdataPtr	 dw	 RRNibble
;		 dw	 RRByte
;		 dw	 RRFast

;RemoteRead	 proc	 near
public	GetRxData
GetRxData	proc	near
	or	cx, cx
	jnz	RR3
	ret
RR3:
	mov	bl, _EBP NICMode
	cmp	bl, NIBBLEMODE
	je	RRNibble
	cmp	bl, BYTEMODE
	je	RRByte
	jmp	RRFast


RRByte:
	loadport
;	 setport StatusPort
;	 RDYWait
	setport CmdPort

IF	Server_386_driver
	push	edi
	push	esi
ELSE
	push	di
	push	si
ENDIF
;---
	mov	bh, _EBP NIC_Cmd
	and	bh, 1fh
	or	bh, _EBP InDirection
ByteModeLoop:
	sub	dx, 2				;data port
	insb
	add	dx, 2				;cmd port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al
	loop	ByteModeLoop
	and	bh, 1fh
	or	bh, _EBP OutDirection
	mov	_EBP NIC_Cmd, bh
	jmp	RRR

RRNibble:
	loadport
	setport CmdPort
	mov	bh, _EBP NIC_Cmd

IF	Server_386_driver
	push	edi
	push	esi
ELSE
	push	di
	push	si
ENDIF
	cmp	_EBP DFRRegister, 0
	jne	WaitRRNibble
;-----
InByteLoop1:
	dec	dx				;status port
	xor	si, si
	in	al, dx				;get status

	mov	ah, al
	inc	dx				;Cmd Port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al
	and	ah, 0f0h
;;;;
	dec	dx				;status port
	xor	si, si
	in	al, dx				;get status

	mov	si, cx
	mov	cl, 4
	shr	al, cl
	mov	cx, si

	or	al, ah
;;;;
	stosb
	inc	dx				;Cmd Port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al

	loop	InByteLoop1
	mov	_EBP NIC_Cmd, bh
	jmp	RRR

WaitRRNibble:
InByteLoop:
	dec	dx				;status port
;;;;;	RDYWait
;	 mov	 bl, _EBP DelayCounter
;	 or	 bl, bl
;	 jz	 RWRDY23
;RWRDY13:
;	 in	 al, 61h
;	 dec	 bl
;	 jnz	 RWRDY13
RWRDY23:
	xor	si, si
WaitLoop13:
	in	al, dx				;get status

;	 test	 al, READY			 ;check RDY signal
;	 jnz	 ReadyNow13
;	 dec	 si
;	 jnz	 WaitLoop13
;ReadyNow13:
;-------------

	mov	ah, al
	inc	dx				;Cmd Port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al
	and	ah, 0f0h
;;;;
	dec	dx				;status port
;;;;;	RDYWait
;	 mov	 bl, _EBP DelayCounter
;	 or	 bl, bl
;	 jz	 RWRDY24
;RWRDY14:
;	 in	 al, 61h
;	 dec	 bl
;	 jnz	 RWRDY14
RWRDY24:
	xor	si, si
WaitLoop14:
	in	al, dx				;get status

;	 test	 al, READY			 ;check RDY signal
;	 jnz	 ReadyNow14
;	 dec	 si
;	 jnz	 WaitLoop14
;ReadyNow14:
;----------------
	mov	si, cx
	mov	cl, 4
	shr	al, cl
	mov	cx, si

	or	al, ah
;;;;
	stosb
	inc	dx				;Cmd Port
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al

	loop	InByteLoop
	mov	_EBP NIC_Cmd, bh
RRR:
IF	Server_386_driver
	pop	esi
	pop	edi
ELSE
	pop	si
	pop	di
ENDIF
	ret

RRFast:
RR1:
IF	Server_386_driver
	push	edi
ELSE
	push	di
ENDIF
	loadport
	setport DataStrobe0
	test	di, 1
	jz	InEven
	insb
IF	Server_386_driver
	dec	ecx
InEven:
	shr	ecx, 1
ELSE
	dec	cx
InEven:
	shr	cx, 1
ENDIF
	rep	insw
	jnc	RR2
	insb
RR2:
IF	Server_386_driver
	pop	edi
ELSE
	pop	di
ENDIF
	ret
GetRxData	endp
;RemoteRead	 endp



;-------------------------------------------------------------------------
;   BufferEmpty
;	check recvive buffer ring is empty or not
;
;   Input
;	Already in NIC Mode
;	Interrupt Disabled
;	DS		DGroup
;	bx		data base
;
;   Output
;	cflag		on=empty
;
;   Modified Register
;	dx, ax
;-------------------------------------------------------------------------
BufferEmpty	proc	near
	loadport
	setport StatusPort
	in	al, dx				;get status
	cmp	_EBP NICMode, FASTMODE		     ;bit 7
	jz	FastBE
	test	al, EMPTY			;Byte/Nibble mode
	jz	short EmptyRet			;zflag
	clc
	ret
FastBE:
	test	al, FEMPTY			;bit 3
	jnz	EmptyRet
	clc
	ret
EmptyRet:
	stc
	ret
BufferEmpty	endp



;-------------------------------------------------------------------------
;   NICInitial
;	Init all internal registers
;
;   Input
;	Already in NIC Mode
;	DS		DGroup
;
;   Output
;	Interrup disabled
;	SCRRegister		AutoTX mode is set
;
;   Modified Registers
;	ax, bx, cx, dx, si
;-------------------------------------------------------------------------
NICInitial	proc	near
	cli
;print I
;---------- Reset -----------
;	mov	al, _EBP EIPRegister
;	or	al, HRESET			;hardware reset
;;	  IDC1	  W_EIP
;	mov	ah, W_EIP
;	call	IDC1

	mov	al, CLEAR+RNOP
	call	WCR
	mov	al, RNOP
	call	WCR

;----------- init SCR ----------
	mov	ah, _EBP NICMode
	push	ax				;save Mode
;;;;	mov	_EBP NICMode, NibbleMode	 ;reset to nibble mode

	mov	al, _EBP SCRRegister
	or	al, AUTOTX			;set auto transmit mode
	mov	_EBP SCRRegister, al
;;	  IDC1	  W_SCR
	mov	ah, W_SCR
	call	IDC1
	pop	ax				;restore NIC Mode
	mov	_EBP NICMode, ah

;	test	ah, FastMode
;	jz	NotFastMode1
;	loadport
;	setport CmdPort
;	xor	al, al
;	out	dx, al				;set fast mode strobe
NotFastMode1:
;----------- init TCR -----------
	mov	al, 0				;disable recv to wait init
;;	  IDC1	  W_TCR 		      ;complete
	mov	ah, W_TCR
	call	IDC1
;----------- init DFR -----------
;;;	 mov	 al, _EBP DFRRegister		      ;delay factor
;;;	   IDC1    W_DFR
;	 mov	 ah, W_DFR
;	 call	 IDC1
;;;;	call	WDFR
;----------- init Node ID --------
IF	Server_386_driver
	lea	esi, _EBP DNodeAddress
ELSE
	lea	si, DNodeAddress
ENDIF
	lodsb
;;	  IDC1	  W_PAR0
	mov	ah, W_PAR0
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR1
	mov	ah, W_PAR1
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR2
	mov	ah, W_PAR2
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR3
	mov	ah, W_PAR3
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR4
	mov	ah, W_PAR4
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR5
	mov	ah, W_PAR5
	call	IDC1
;---------- init EIP ------------
	mov	al, _EBP EIPRegister
;;	  IDC1	  W_EIP
	mov	ah, W_EIP
	call	IDC1
;----------- Init SPR -----------
	mov	al, _EBP SPRRegister
	mov	_EBP Next_Page, al		 ;Used in INTHandler
	mov	_EBP prepage, 0
;;	  IDC1	  W_SPR
	mov	ah, W_SPR
	call	IDC1
;----------- Init EPR -----------
	mov	al, _EBP EPRRegister
;;	  IDC1	  W_EPR
	mov	ah, W_EPR
	call	IDC1
;----------- Init CPR -----------
	mov	al, _EBP SPRRegister
;;	  IDC1	  W_CPR
	mov	ah, W_CPR
	call	IDC1
;----------- Init NPR -----------
	mov	al, _EBP SPRRegister
;;	  WNPR
	call	WNPR
;----------- init TCR -----------
	mov	al, _EBP TCRRegister
	or	al, TXSUCINT+T16INT
	mov	_EBP TCRRegister, al
;;	  IDC1	  W_TCR 			  ;complete
	mov	ah, W_TCR
	call	IDC1
	ret
NICInitial	endp



;-------------------------------------------------------------------------
;   GetISRStatus
;	Get the interrupt status of NIC
;
;   Input
;	DS		DGroup
;
;   Output
;	ZFlag		on means has Nothing to do
;
;   Modified Register
;	ax, dx, bp, cx
;-------------------------------------------------------------------------
public	GetISRStatus
;GetISRStatus	 proc	 near
;
;	 push	 bx
;
;;;;	 call	 NIC_Mode
;	 Mode_NIC
;
;;;	   IDC2    R_STS			   ;get status register
;	 mov	 ah, R_STS
;	 call	 IDC2
;	 test	 al, TS0+TS1			 ;check T16
;	 jz	 GIS3
;
;	 mov	 al, CLEAR+RNOP 		 ;issue CLEAR to reset TXBZ0,1
;	 call	 WCR				 ;flag
;	 mov	 al, RNOP
;	 call	 WCR
;GIS3:
;
;	 call	 BufferEmpty			 ;check buffer empty
;	 jc	 GIS1
;;;;	 call	 Prn_Mode
;	 Mode_Prn
;	 or	 ax, 0ffh			 ;buffer not empty
;	 pop	 bx
;	 ret
;GIS1:
;
;	 cmp	 CurrTx, 0
;	 jz	 GISRRet			 ;no xmit in progress
;
;	 loadport
;	 setport StatusPort
;	 in	 al, dx
;	 test	 al, CurrTx
;	 jnz	 GIS2
;;;;	 call	 Prn_Mode
;	 Mode_Prn
;	 or	 ax, 0ffh			 ;xmit complete
;	 pop	 bx
;	 ret
;GIS2:
;GISRRet:
;;;;	 call	 Prn_Mode
;	 Mode_Prn
;	 xor	 ax, ax 			 ;xmit in progress
;	 pop	 bx
;	 ret
;GetISRStatus	 endp

GetISRStatus	proc
	push	bx

	call	NIC_Mode
;;;	Mode_NIC

;;	  IDC2	  R_STS 			  ;get status register
	mov	ah, R_STS
	call	IDC2
	test	al, TS0+TS1			;check T16
	jz	GIS3

     mov     _EBP T16Flag, DYES
	mov	al, CLEAR+RNOP			;issue CLEAR to reset TXBZ0,1
	call	WCR				;flag
	mov	al, RNOP
	call	WCR
     jmp     short GIS4

GIS3:
	loadport
	setport StatusPort
	in	al, dx
	cmp	_EBP NICMode, FASTMODE
	je	GISFast
	test	al, EMPTY			;Byte/Nibble mode
	jz	GISTx				;zflag
	jmp	short GIS4
GISFast:
	test	al, FEMPTY			;bit 3
	jz	GIS4
GISTx:
	cmp	_EBP CurrTx, 0
	jz	GISRRet 			;no xmit in progress

	test	al, _EBP CurrTx
	jnz	GISRRet
GIS4:
	call	Prn_Mode
;;;	Mode_Prn
	or	al, 0ffh			;xmit complete
	pop	bx
	ret
GISRRet:
	call	Prn_Mode
;;;	Mode_Prn
	xor	ax, ax				;xmit in progress
	pop	bx
	ret
GetISRStatus	endp





;-------------------------------------------------------------------------
;   ShutdownNIC
;	Driver Shutdown places the adapter into a safe, nonactive state.
;	The DriverSend routine will not be called when the adapter is in
;	a shutdown state.
;
;   Assumes
;	DS		DGroup
;	Interrupt disabled, but may be re-enabled
;
;   Output
;   Modified Registers
;	ax, cx, dx, bp
;-------------------------------------------------------------------------
public	ShutdownNIC
ShutdownNIC	proc	near
	push	bx
;	xor	bx, bx
	mov	_EBP DisableTx, DYES		 ;set disable xmit mode

	mov	cl, _EBP TCRRegister
	mov	al, 1				;disbale receive mode
	call	SetRxMode
	mov	_EBP TCRRegister, cl		 ;restore old value

	pop	bx
	ret
ShutdownNIC	endp


;-------------------------------------------------------------------------
;   ResetNIC
;	Reset the hardware adapter. If the driver was previously shutdown,
;	an application will call this routine to bring the physical board
;	out of shutdown condition and back into full operation.
;	This routine will not be called if the driver and physical board
;	are in a permanent shutdown condition.
;
;   Assumes
;	DS		DGroup
;	Interrupt disabled
;
;   Output
;	Interrupt disabled
;
;   Modified Registers
;	ax, cx, dx
;-------------------------------------------------------------------------
public	ResetNIC
ResetNIC	proc	near
	push	bx
IF	Server_386_driver
	push	esi
ELSE
	push	si
ENDIF
	call	NICInitial
;	xor	bx, bx
	mov	_EBP DisableTx, DNO
mov	_EBP TxFlag, 0
mov	_EBP TxWait, 0
mov	_EBP TxBusy, 0
mov	_EBP CurrTx, 0
IF	Server_386_driver
	pop	esi
ELSE
	pop	si
ENDIF
	pop	bx
	ret
ResetNIC	endp


;-------------------------------------------------------------------------
; DCancelRequest
;
;   Description :
;	    This routine cancels the ECB queued in Hardware Library
;
;   Assumes:
;	    ES:SI is pointer to ECB we want to cancel
;	    DS is setup
;	    Interrupts are DISABLED
;
;   Returns:
;	    ES:SI is preserved
;	    Completion code in AL:
;	    00	 Buffer was located and canceled.
;	    FF	 Buffer was not found to be in use by the driver
;
;   Modified Register
;	es, si are preserved
;-------------------------------------------------------------------------
public	DCancelRequest
IF	Server_386_driver
DCancelRequest	proc	near
	lea	edi, _EBP Tx0Struct

	cmp	esi, ds:[edi].TCB_off
	jne	AnotherTCB
	mov	ax, es
	cmp	ax, ds:[edi].TCB_seg
	je	DCFound

AnotherTCB:
	lea	edi, _EBP Tx1Struct
	cmp	esi, ds:[edi].TCB_off
	jne	DCNotFound
	mov	ax, es
	cmp	ax, ds:[edi].TCB_seg
	jne	DCNotFound
DCFound:
	cmp	ds:[edi].UseFlag, 0		 ;confirm check
	je	DCNotFound

	cmp	ds:[edi].UseFlag, 1		 ;check wait status
	je	DCWaitPacket
	mov	ds:[edi].UseFlag, 3		 ;set cancel flag
	xor	al, al
	ret
DCWaitPacket:
	mov	_EBP TxWait, 0			     ;clear Tx wait flag
	mov	ds:[edi].UseFlag, 0		 ;clear use flag
	xor	al, al
	ret
DCNotFound:
	mov	al, 0ffh
	ret
DCancelRequest	endp
ELSE
DCancelRequest	proc	near
	lea	di, Tx0Struct

	cmp	si, ds:[di].TCB_off
	jne	AnotherTCB
	mov	ax, es
	cmp	ax, ds:[di].TCB_seg
	je	DCFound

AnotherTCB:
	lea	di, Tx1Struct
	cmp	si, ds:[di].TCB_off
	jne	DCNotFound
	mov	ax, es
	cmp	ax, ds:[di].TCB_seg
	jne	DCNotFound
DCFound:
	cmp	ds:[di].UseFlag, 0		;confirm check
	je	DCNotFound

	cmp	ds:[di].UseFlag, 1		;check wait status
	je	DCWaitPacket
	mov	ds:[di].UseFlag, 3		;set cancel flag
	xor	al, al
	ret
DCWaitPacket:
	mov	TxWait, 0			;clear Tx wait flag
	mov	ds:[di].UseFlag, 0		;clear use flag
	xor	al, al
	ret
DCNotFound:
	mov	al, 0ffh
	ret
DCancelRequest	endp
ENDIF



;-------------------------------------------------------------------------
;   DCloseSocket
;	This routine cancels all ECBs according the socket number
;
;   Assumes
;	DS		DGroup
;	dx		socket number
;	Interrupt disabled
;
;   Return
;	nothing
;	No registers are saved
;-------------------------------------------------------------------------
public	DCloseSocket
IF	Server_386_driver
DCloseSocket	proc	near

	lea	edi, _EBP Tx0Struct
	mov	esi, ds:[edi].TCB_off
	mov	es, ds:[edi].TCB_seg
	cmp	dx, es:[esi].10 		 ;socket number
	je	DSFound

	lea	edi, _EBP Tx1Struct
	mov	esi, ds:[di].TCB_off
	mov	es, ds:[edi].TCB_seg
	cmp	dx, es:[esi].10 		 ;socket number
	jne	DSRet
DSFound:
	call	DCancelRequest
DSRet:
	ret
DCloseSocket	endp
ELSE
DCloseSocket	proc	near
;	xor	bx, bx

	lea	di, Tx0Struct
	mov	si, ds:[di].TCB_off
	mov	es, ds:[di].TCB_seg
	cmp	dx, es:[si].10			;socket number
	jne	DSFound11
	call	DCancelRequest
DSFound11:

	lea	di, Tx1Struct
	mov	si, ds:[di].TCB_off
	mov	es, ds:[di].TCB_seg
	cmp	dx, es:[si].10			;socket number
	jne	DSRet
DSFound:
	call	DCancelRequest
DSRet:
	ret
DCloseSocket	endp
ENDIF



;-------------------------------------------------------------------------
;   SetRxMode
;	set the receive packet mode of adapter
;
;   Input
;	DS		DGroup
;	al		receive mode bit map
;				bit 0 -- disable receive mode
;				bit 1 -- receive physical address
;				bit 2 -- receive broadcast address
;				bit 3 -- receive multicast address
;				bit 4 -- receive all packet
;
;   Output
;	Cflag		Set on means error
;
;   Modified registers
;	ax, dx
;-------------------------------------------------------------------------
public	SetRxMode
SetRxMode	proc	near
;	or	al, al
;	jnz	SRM1
	test	al, 1
	jz	SRM1
	mov	ah, RXOFF			;disable receive
	jmp	short SetMode1
SRM1:
	test	al, Bit4			;receive all
	jz	SRM2
	mov	ah, RXALL
	jmp	short SetMode1
SRM2:
	cmp	al, 8				;multicast only
	jne	SM1
	jmp	SRMError
SM1:
	cmp	al, 6				;physical or broadcast
	ja	SRM3
	mov	ah, RXPB			;physical and broadcast
	jmp	short SetMode1
SRM3:
	mov	ah, RXPBM			;physcal,broadcast and muticast
SetMode1:
	push	bx
	push	cx
;	xor	bx, bx
	and	_EBP TCRRegister, not RXPBM	     ;clear MM0, MM1
	or	_EBP TCRRegister, ah		     ;set recv mode
;------------ Select NIC ------------
	call	NIC_Mode
;;;	Mode_NIC

	mov	al, _EBP TCRRegister
;;	  IDC1	  W_TCR
	mov	ah, W_TCR
	call	IDC1

	call	Prn_Mode
;;;	Mode_Prn

	pop	cx
	pop	bx
	clc
	ret
SRMError:
	stc
	ret
SetRxMode	endp


;-------------------------------------------------------------------------
;   setAdapterAddress
;   modified from setNodeAddress
;	Program adapter, and set the node ID
;
;   Input
;	DS		DGroup
;	es:si		New Node ID pointer
;
;   Output
;	Cflag		on means error
;
;   Modified Register
;	None
;-------------------------------------------------------------------------
public	SetAdapterAddress
SetAdapterAddress  proc    near
	push	ax
	push	bx
	push	dx
IF	Server_386_driver
	push	ecx
	push	edi
	push	esi

	lea	edi, _EBP DNodeAddress
	mov	ecx, 6
ELSE
	push	cx
	push	di
	push	si

	lea	di, DNodeAddress
	mov	cx, 6
ENDIF
	push	ds
	push	es
	pop	ds
	pop	es
	rep	movsb
	push	ds
	push	es
	pop	ds
	pop	es

	call	NIC_Mode			;set to NIC Mode
;;;	Mode_NIC

IF	Server_386_driver
	lea	esi, _EBP DNodeAddress
ELSE
	lea	si, DNodeAddress
ENDIF
	lodsb
;;	  IDC1	  W_PAR0
	mov	ah, W_PAR0
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR1
	mov	ah, W_PAR1
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR2
	mov	ah, W_PAR2
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR3
	mov	ah, W_PAR3
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR4
	mov	ah, W_PAR4
	call	IDC1
	lodsb
;;	  IDC1	  W_PAR5
	mov	ah, W_PAR5
	call	IDC1

	call	Prn_Mode
;;;	Mode_Prn
	clc
IF	Server_386_driver
	pop	esi
	pop	edi
	pop	ecx
ELSE
	pop	si
	pop	di
	pop	cx
ENDIF
	pop	dx
	pop	bx
	pop	ax
	ret
SetAdapterAddress  endp


;-------------------------------------------------------------------------
;   GetNodeAddress
;	Return the Node ID
;
;   Input
;	DS		DGroup
;	es:di		buffer
;
;   Output
;	es:di		point to the buffer saving Node ID
;
;   Modified Register
;	NONE
;-------------------------------------------------------------------------
public	GetNodeAddress
GetNodeAddress	proc	near
	push	bx
IF	Server_386_driver
	push	ecx
	push	edi
	push	esi
	lea	esi, _EBP DNodeAddress
ELSE
	push	cx
	push	di
	push	si
	lea	si, DNodeAddress
ENDIF
	mov	cx, 6
	rep	movsb
IF	Server_386_driver
	pop	esi
	pop	edi
	pop	ecx
ELSE
	pop	si
	pop	di
	pop	cx
ENDIF
	pop	bx
	ret
GetNodeAddress	endp


;-------------------------------------------------------------------------
;   HwLibAddMulticastAddress
;
;   Input
;	es:si		6 byte buffer holding the MC Address
;	ds		DGroup
;
;   Output
;	ax		=0 successful
;			=BadAddress   address invalid
;			=NoAddressBuffer
;
;   Modified Registers
;	All
;-------------------------------------------------------------------------
public	HwLibAddMulticastAddress
HwLibAddMulticastAddress	proc	near
	xor	ax, ax
	ret
HwLibAddMulticastAddress	endp


;-------------------------------------------------------------------------
;   HwLibDelMulticastAddress
;
;   Input
;	es:si		6 byte buffer holding the MC Address
;	ds		DGroup
;
;   Output
;	ax		=0 successful
;			=BadAddress   address invalid
;			=AddressNotPresent
;
;   Modified Registers
;	All
;-------------------------------------------------------------------------
public	HwLibDelMulticastAddress
HwLibDelMulticastAddress	proc	near
	xor	ax, ax
	ret
HwLibDelMulticastAddress	endp



;-------------------------------------------------------------------------
;   HwLibMulticastChange
;
;   Input
;	ds:si		point to a table of multicast address
;			each entry has 8 byte -- 6 byte address and 2 byte flag
;			flag not zero means valid address
;	ds		DGroup
;	cx		number of entries in table
;
;   Output
;	none
;
;   Modified Registers
;	All
;-------------------------------------------------------------------------
public	HwLibMulticastChange
HwLibMulticastChange	proc	near
	ret
HwLibMulticastChange	endp


;---------------------------------------------------------------------------
;   MaskInterruptMaskRegister
;
;   Input
;	DS		DGroup
;	interrupt disable
;
;   Output
;	IMR is masked
;	interrupt disable
;
;   Modified Registers
;	ax, dx, bp, cx
;---------------------------------------------------------------------------
public	MaskInterruptMaskRegister
MaskInterruptMaskRegister	proc	near
;IF	 0
	cmp	_EBP NICMode, NIBBLEMODE
	jne	MIMRRet
	loadport
	setport CmdPort
	;;;+ 9/18/1993 Y.L. Tang
 ;;	mov	al, _EBP NIC_Cmd
	in	al, dx
	;;;-
	and	al, not IRQEN
	out	dx, al
	jmp	$+2
MIMRRet:
;ENDIF
	ret
MaskInterruptMaskRegister	endp



;---------------------------------------------------------------------------
;   UnMaskInterruptMaskRegister
;
;   Input
;	DS		DGroup
;	interrupt disable
;
;   Output
;	IMR is unmasked
;	interrupt disable
;
;   Modified Registers
;	ax, dx, bp, cx
;---------------------------------------------------------------------------
public	UnMaskInterruptMaskRegister
UnMaskInterruptMaskRegister	proc	near
;IF	 0
	cmp	_EBP NICMode, NIBBLEMODE
	jne	UMIMRRet
	loadport
	setport CmdPort
	;;+ 9/18/1993 Y.L. Tang
     ;; mov	al, _EBP NIC_Cmd
	in	al, dx
	;;-
	or	al, IRQEN
	out	dx, al
	jmp	$+2
UMIMRRet:
;ENDIF
	ret
UnMaskInterruptMaskRegister	endp



;---------------------------------------------------------------------------
;   GetTick
;   Input
;   output
;	ax		Tick counter (Low word)
;   Modified Registers
;	none
;---------------------------------------------------------------------------
public	GetTick
GetTick proc	near
IF	NDIS_OS2_WKS_driver or Server_286_driver
	xor	ax, ax
	ret
ENDIF

IF	NDIS_DOS_WKS_driver or Packet_Driver or ODI_DOS_WKS_driver or IPX_WKS_driver
	push	es
	push	di
	xor	di, di
	mov	es, di
	mov	di, 046ch
	mov	ax, es:[di]
	pop	di
	pop	es
	ret
ENDIF

IF ODI_OS2_WKS_driver	;by Ted Tai

	SetDsBX 			; restore DS
	mov	ax, TickCount
	push	ax			; save AX
	SetSelector
	pop	ax			; restore AX
	ret
ENDIF

;by ted tai
IF	Server_386_driver

;+ By Beny Chen (921202)
	MSMGetCurrentTime			;MACRO
	ret

ENDIF


GetTick endp


;---------------------------------------------------------------------------
;   FragmentRoVirtual
;	Turn Physical address to virtual address
;
;   Input
;	es:si		Fragment structure
;	ax:bx		physical address
;
;   Output
;	ax:bx		Virtual address
;
;   Modified Registera
;	ax, bx, cx, dx
;---------------------------------------------------------------------------
FragmentToVirtual	proc	near
IF	NDIS_OS2_WKS_driver
	cmp	es:[si].cd_ptr_type,CT_GDT
	jne	@F
	ret
@@:
	push	ds
	push	si

	mov	ds,cs:cs_ds
	mov	si,segtx
	mov	dl,DevHlp_PhysToGDTSelector
	call	devHelper
	mov	ax, si
	xor	bx, bx
	pop	si
	pop	ds
	ret
ENDIF

IF	NDIS_DOS_WKS_driver
	ret
ENDIF

IF	Packet_Driver
	ret
ENDIF

IF	IPX_WKS_driver
	ret
ENDIF

IF	ODI_DOS_WKS_driver or ODI_OS2_WKS_driver
	ret
ENDIF

IF	Server_386_driver
	ret
ENDIF

IF	Server_286_driver
	ret
ENDIF

FragmentToVirtual	endp



;-------------------------------------------------------------------------
;   WDUMMY
;   Input
;	ds
;-------------------------------------------------------------------------
;;WDUMMY  macro
;;	  local   WD1, WD2
WDUMMY	proc	near
	test	_EBP NICMode, FASTMODE
	jnz	WD1
WD3:
	loadport
	setport StatusPort
	RDYWait

	setport CmdPort
	mov	al, _EBP NIC_Cmd
;	or	al, _EBP OutDirection
	out	dx, al

	mov	al, W_DUMMY
	setport DataPort
	OutCommand

	setport StatusPort
	RDYWait

	setport CmdPort
	mov	al, _EBP NIC_Cmd
;	or	al, _EBP OutDirection
	out	dx, al
	jmp	WD2
WD1:
;;;;	    RDYWaitF
	mov	al, W_DUMMY
	OutCommandF
WD2:
;;	  endm
	ret
WDUMMY	endp


;-------------------------------------------------------------------------
;   WCR
;   Input
;	ds
;	al
;-------------------------------------------------------------------------
;;WCR	  macro
;;	  local   WC1, WC2
WCR	proc	near
	test	_EBP NICMode, FASTMODE
	jnz	WC1
WC3:
	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;;	pop	ax
mov	ax, bx
	or	al, W_CR
	setport DataPort
	OutCommand
	setport StatusPort
	RDYWait
	setport CmdPort
	mov	al, _EBP NIC_Cmd
;	or	al, _EBP OutDirection
	out	dx, al
;slow
;slow
	jmp	WC2
WC1:
	or	al, W_CR
	OutCommandF
WC2:
;;	  endm
	ret
WCR	endp


;-------------------------------------------------------------------------
;   WNPR
;
;   Input
;	ds
;	al		NPR data
;-------------------------------------------------------------------------
;;WNPR	  macro
;;	  local   WN1, WN2
WNPR	proc	near

	test	_EBP NICMode, FASTMODE
	jnz	WN1

	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;;	pop	ax
mov	ax, bx
	or	al, W_NPR
	setport DataPort
	OutCommand
	setport StatusPort
	RDYWait
	setport CmdPort
	mov	al, _EBP NIC_Cmd
	out	dx, al
	jmp	WN2
WN1:
	or	al, W_NPR
	OutCommandF
WN2:
;;	  endm
	ret
WNPR	endp


;-------------------------------------------------------------------------
;   WTBR
;
;   Input
;	ds
;	al		TBR1
;	ah		TBR0
;
;   Modified Register
;	ax, dx
;-------------------------------------------------------------------------
;;WTBR	  macro
;;	  local   WT1, WT2
WTBR	proc	near

	test	_EBP NICMode, FASTMODE
	jnz	WT1

	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;;	pop	ax
mov	ax, bx
	or	al, W_TBR
	setport DataPort
	OutCommand
;call	 TimeDelay
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;;	pop	ax
mov	ax, bx
	mov	al, ah
;	mov	ah, _EBP OutDirection
	OutData
	jmp	WT2
WT1:
	or	al, W_TBR
	OutCommandF
	mov	al, ah
	loadport
	setport DataStrobe0
	out	dx, al
WT2:
;;	  endm
	ret
WTBR	endp


;-------------------------------------------------------------------------
;   WRSA
;	DIC Command for remote start address
;
;   Input
;	ds		DGroup
;	bx		data base
;	al		RSA1
;	ah		RSA0
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;WRSA	  macro
;;	  local   WR1, WR2
WRSA	proc	near

	test	_EBP NICMode, FASTMODE
	jz	WR3
	jmp	WR1
WR3:
	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;;	pop	ax
mov	ax, bx
	or	al, W_RSA
	setport DataPort
	OutCommand
;call	 TimeDelay
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;;	pop	ax
;;;	mov	al, ah
mov	al, bh
;	mov	ah, _EBP OutDirection
	OutData

	setport StatusPort
	RDYWait
	setport CmdPort
	mov	al, _EBP NIC_Cmd
	and	al,1fh
	or	al, _EBP InDirection
	out	dx, al
	jmp	WR2
WR1:
	or	al, W_RSA
	OutCommandF
	mov	al, ah
	loadport
	setport DataStrobe0
	out	dx, al
WR2:
;;	  endm
	ret
WRSA	endp


;-------------------------------------------------------------------------
;   WRSA1
;	IDIC Command for remote start address
;
;   Input
;	ds		DGroup
;	bx		data base
;	al		RSA1
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;WRSA1   macro
;;	  local   WR11, WR12
WRSA1	proc	near

	test	_EBP NICMode, FASTMODE
	jnz	WR11
WR13:
	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
	mov	al, W_RSA1
	setport DataPort
	OutCommand
	setport StatusPort
	RDYWait
;;;	pop	ax
mov	ax, bx
;	mov	ah, _EBP OutDirection
	OutData
	jmp	WR12
WR11:
	push	ax
;;;	RDYWaitF
	mov	al, W_RSA1
	OutCommandF
;;;	RDYWaitF
	pop	ax
	loadport
	setport DataStrobe0
	out	dx, al
WR12:
;;	  endm
	ret
WRSA1	endp


;-------------------------------------------------------------------------
;   WRSA0
;	IDIC Command for remote start address
;
;   Input
;	ds		DGroup
;	bx		data base
;	al		RSA0
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;WRSA0   macro
;;	  local   WR01, WR02
WRSA0	proc	near

	test	_EBP NICMode, FASTMODE
	jz	WR03
	jmp	WR01
WR03:
	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
	mov	al, W_RSA0
	setport DataPort
	OutCommand
	setport StatusPort
	RDYWait
;;;	pop	ax
mov	ax, bx
;	mov	ah, _EBP OutDirection
	OutData

	setport StatusPort
	RDYWait
	setport CmdPort
	mov	al, _EBP NIC_Cmd
	and	al, 1fh
	or	al, _EBP InDirection
	out	dx, al
	jmp	WR02
WR01:
	push	ax
;;;	RDYWaitF
	mov	al, W_RSA0
	OutCommandF
;;;	RDYWaitF
	pop	ax
	loadport
	setport DataStrobe0
	out	dx, al
WR02:
;;	  endm
	ret
WRSA0	endp


;-------------------------------------------------------------------------
;   WDFR
;	IDIC Command 1 -- WDFR
;
;   Input
;	CmdArg		Command Code
;	ds		DGroup
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;WDFR	  macro   CmdArg
;;	  local   ID1, ID2
WDFR	proc	near

	test	_EBP NICMode, FASTMODE
	jz	WID4
	jmp	WID1
WID4:
	loadport
	setport StatusPort
	RDYWait
	mov	al, W_DFR

	setport DataPort
	OutCommand
	setport StatusPort
	RDYWait
	mov	al, _EBP DFRRegister
	OutData

	setport StatusPort
	RDYWait
	mov	al, _EBP RDFRRegister
	OutData
	jmp	WID2
WID1:
	mov	al, W_DFR
	OutCommandF
	loadport
	setport DataStrobe0
	mov	al, _EBP DFRRegister
	out	dx, al
	mov	al, _EBP RDFRRegister
	out	dx, al
WID2:
;;	  endm
	ret
WDFR	endp


;-------------------------------------------------------------------------
;   IDC1
;	IDIC Command 1
;
;   Input
;	CmdArg		Command Code
;	ds		DGroup
;	bx		data base
;	al		IDC data
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;IDC1	  macro   CmdArg
;;	  local   ID1, ID2
IDC1	proc	near

	test	_EBP NICMode, FASTMODE
	jz	ID4
	jmp	ID1
ID4:
	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;	  mov	  al, CmdArg
	mov	al, ah

	setport DataPort
	OutCommand
	setport StatusPort
	RDYWait
;;;	pop	ax
;;;	push	ax
mov	ax, bx
;	mov	ah, _EBP OutDirection
	OutData
;;;	pop	ax
mov	ax, bx
IFNDEF	OLD
	cmp	ah, W_DFR
	jne	IDC1Ret
	setport StatusPort
;;;	push	ax
	RDYWait
;;;	pop	ax
mov	ax, bx
;	mov	ah, OutDirection
	mov	al, _EBP RDFRRegister
	OutData
IDC1Ret:
ENDIF
	jmp	ID2
ID1:
	push	ax
;;;	RDYWaitF
;;	  mov	  al, CmdArg
	mov	al, ah

	OutCommandF
;;;	RDYWaitF
	pop	ax
	loadport
	setport DataStrobe0
	out	dx, al
IFNDEF	OLD
	cmp	ah, W_DFR
	jne	IDC1RETF
	mov	al, _EBP RDFRRegister
	out	dx, al
IDC1RETF:
ENDIF
ID2:
;;	  endm
	ret
IDC1	endp


;-------------------------------------------------------------------------
;   IDC2
;	IDIC Command 2
;
;   Input
;	CmdArg		Command Code
;	ds		DGroup
;	bx		data base
;
;   Output
;	al		data
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;IDC2	  macro   CmdArg
;;	  local   ID21,ID22,ID23
IDC2	proc	near

	test	_EBP  NICMode, FASTMODE
	jz	ID23
	jmp	ID21
ID23:
;;	  RDYWait
;;	  mov	  al, CmdArg
	loadport
	setport StatusPort
;;;	push	ax
mov	bx, ax
	RDYWait
;;;	pop	ax
;;;	mov	al, ah
mov	al, bh

;	 OutIDC2Cmd
	setport DataPort
	OutCommand
	setport StatusPort
	RDYWait

	setport CmdPort
	mov	al, _EBP NIC_Cmd
and al, 1fh
	or	al, _EBP InDirection
	out	dx, al

	ReadData
;;;	push	ax
mov	bx, ax
;;	  WDUMMY
	call	WDUMMY
;;;	pop	ax
mov	ax, bx
	jmp	ID22

ID21:
;;	  RDYWaitF
;;	  mov	  al, CmdArg
	mov	al, ah
	OutCommandF
	loadport
	setport DataStrobe0
	in	al, dx
	push	ax
;;	  WDUMMY
	call	WDUMMY
	pop	ax
ID22:
;;	  endm
	ret
IDC2	endp


;-------------------------------------------------------------------------
;   WDFRINIT
;	IDIC Command 1	for initial   --  WDFR
;
;   Input
;	ds		DGroup
;
;   Modified Regidter
;	ax, bx, dx
;-------------------------------------------------------------------------
;;WDFRINIT macro   CmdArg
;;	  local   IID1, IID2
public	WDFRINIT
IF	0
WDFRINIT	proc	near

	mov	bh, _EBP NIC_Cmd
	cmp	_EBP NICMode, FASTMODE
	jne	WDI4
	jmp	WDI5
WDI4:
	call	TimeDelay
	mov	al, W_DFR
;-----------
;	OutCommand
	loadport
	setport DataPort
	out	dx, al
	call	TimeDelay
	setport CmdPort
	mov	al, bh
	xor	al, CS0
	out	dx, al
;------------
	call	TimeDelay
	mov	al, _EBP DFRRegister
;-----------
;	OutData
	setport DataPort
	out	dx, al
	call	TimeDelay
	setport CmdPort
	xor	bh, DS0+DS1
	mov	al, bh
	out	dx, al
	call	TimeDelay
;-----------
;;	OutData
	setport DataPort
	mov	al, _EBP RDFRRegister
	out	dx, al
;	call	TimeDelay
	setport CmdPort
	xor	bh, DS0+DS1
	mov	al, bh
	out	dx, al
	call	TimeDelay
	mov	_EBP NIC_Cmd, bh
	jmp	short WDI6
WDI5:
	loadport
	setport CmdPort
	mov	al, DS1+ICEN
	out	dx, al				;1
	call	TimeDelay
	mov	al, W_DFR
	setport DataPort
	out	dx, al
	call	TimeDelay
	setport CmdPort
	mov	al, CS0+DS1+ICEN
	out	dx, al				;9
	call	TimeDelay
	setport DataPort
	mov	al, _EBP DFRRegister
	out	dx, al
	call	TimeDelay
	setport CmdPort
	mov	al, DS0+DS1+CS0+ICEN
	out	dx, al				;b
	call	TimeDelay
	setport DataPort
	mov	al, _EBP RDFRRegister
	out	dx, al
	setport CmdPort
	mov	al, CS0+DS1+ICEN
	out	dx, al				;9
	call	TimeDelay
	mov	al, CS0+DS0+DS1+ICEN
	out	dx, al				;b
	call	TimeDelay
;;	mov	al, ICEN			; 4/27/1993 Andge Chen
	mov	al, IRQEN+ICEN
	out	dx, al				;0
WDI6:
;;	  endm
	ret
WDFRINIT	endp
ENDIF


WDFRINIT	proc	near

	mov	bh, _EBP NIC_Cmd
	cmp	_EBP NICMode, FASTMODE
	jne	WDI4
	jmp	WDI5
WDI4:
	call	TimeDelay
	mov	al, W_DFR
;-----------
;	OutCommand
	loadport
	setport DataPort
	out	dx, al
	call	TimeDelay
	setport CmdPort
	mov	al, bh
	xor	al, CS0
	out	dx, al
;------------
	call	TimeDelay
	mov	al, _EBP DFRRegister
;-----------
;	OutData
	setport DataPort
	out	dx, al
	call	TimeDelay
	setport CmdPort
	xor	bh, DS0+DS1
	mov	al, bh
	out	dx, al
	call	TimeDelay
;-----------
;;	OutData
	setport DataPort
	mov	al, _EBP RDFRRegister
	out	dx, al
;	call	TimeDelay
	setport CmdPort
	xor	bh, DS0+DS1
	mov	al, bh
	out	dx, al
	call	TimeDelay
	mov	_EBP NIC_Cmd, bh
	jmp	WDI6
WDI5:
	loadport
	setport CmdPort
	in	al, dx
	mov	bh, al
	and	bh, ICEN
	or	bh, DS1
;	mov	al, DS1+ICEN
	mov	al, bh
	out	dx, al				;1
	call	TimeDelay
	mov	al, W_DFR
	setport DataPort
	out	dx, al
	call	TimeDelay
	setport CmdPort
;	mov	al, CS0+DS1+ICEN
	or	bh, CS0
	mov	al, bh
	out	dx, al				;9
	call	TimeDelay
	setport DataPort
	mov	al, _EBP DFRRegister
	out	dx, al
	call	TimeDelay
	setport CmdPort
;	mov	al, DS0+DS1+CS0+ICEN
	or	bh, DS0
	mov	al, bh
	out	dx, al				;b
	call	TimeDelay
	setport DataPort
	mov	al, _EBP RDFRRegister
	out	dx, al
	setport CmdPort
;	mov	al, CS0+DS1+ICEN
	and	bh, not DS0
	mov	al, bh
	out	dx, al				;9
	call	TimeDelay
;	mov	al, CS0+DS0+DS1+ICEN
	or	bh, DS0
	mov	al, bh
	out	dx, al				;b
	call	TimeDelay
;;	mov	al, ICEN			; 4/27/1993 Andge Chen
;	mov	al, IRQEN+ICEN
	and	bh, ICEN
	or	bh, IRQEN
	mov	al, bh
	out	dx, al				;0
WDI6:
;;	  endm
	ret
WDFRINIT	endp



;-------------------------------------------------------------------------
;   IDC1INIT
;	IDIC Command 1	for initial
;
;   Input
;	CmdArg		Command Code
;	ds		DGroup
;	bx		data base
;	al		IDC data
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;IDC1INIT macro   CmdArg
;;	  local   IID1, IID2
IDC1INIT	proc	near

	test	_EBP NICMode, FASTMODE
	jz	IID4
	jmp	IID1
IID4:
	loadport
	setport StatusPort
	push	ax
	RDYWait
;;	  mov	  al, CmdArg
	mov	al, ah
;-----------
;	OutCommand
;	call	TimeDelay
	setport DataPort
	out	dx, al
call	TimeDelay
	setport CmdPort
	mov	al, _EBP NIC_Cmd
	xor	al, CS0
;	or	al, _EBP OutDirection
	out	dx, al
;------------
	setport StatusPort
	RDYWait
	pop	ax
	push	ax
;	mov	ah, _EBP OutDirection
;-----------
;	OutData
;	call	TimeDelay
	setport DataPort
	out	dx, al
	call	TimeDelay
	setport CmdPort
	xor	_EBP NIC_Cmd, DS0 or DS1
	mov	al, _EBP NIC_Cmd
;	or	al, ah
	out	dx, al
;-----------
	pop	ax
	jmp	$+2
	jmp	$+2
	jmp	IID2
IID1:
	push	ax
;;;;	    RDYWaitF
;;	  mov	  al, CmdArg
	mov	al, ah
	OutCommandF
;	call	TimeDelay
;;;	RDYWaitF
	pop	ax
	loadport
	setport DataStrobe0
	out	dx, al
;	call	TimeDelay
;IFNDEF  OLD
;	 cmp	 ah, W_DFR
;	 jne	 IDC1INITRETF
;	 mov	 al, RDFRRegister
;	 out	 dx, al
;IDC1INITRETF:
;ENDIF
	jmp	$+2
	jmp	$+2
IID2:
;;	  endm
	ret
IDC1INIT	endp


;-------------------------------------------------------------------------
;   IDC2INIT
;	IDIC command 2
;
;   Input
;	CmdArg		Command Code
;	ds		DGroup
;	bx		data base
;
;   Output
;	al		data
;
;   Modified Regidter
;	ax, dx
;-------------------------------------------------------------------------
;;IDC2INIT macro   CmdArg
;;	  local   IID21,IID22,IID23
IDC2INIT	proc	near

	test	_EBP NICMode, FASTMODE
	jz	IID23
	jmp	IID21
IID23:
;;	  RDYWait
;;	  mov	  al, CmdArg
	loadport
	setport StatusPort
	push	ax
	RDYWait
	pop	ax
	mov	al, ah
;------------
;	OutIDC2Cmd
;	call	TimeDelay
	setport DataPort
	out	dx, al
call	TimeDelay
	setport CmdPort
	mov	al, _EBP NIC_Cmd
	xor	al, CS0
;;	or	al, InDirection
	out	dx, al
;------------
	jmp	$+2
	jmp	$+2
	jmp	$+2
	setport StatusPort
	RDYWait

	setport CmdPort
	mov	al, _EBP NIC_Cmd
	and	al, 1fh
	or	al, _EBP InDirection
	out	dx, al

	ReadData
	push	ax
;;	  WDUMMY
	call	WDUMMY
;;;	call	TimeDelay
	pop	ax
	jmp	IID22
IID21:
;;	  RDYWaitF
;;	  mov	  al, CmdArg
	push	ax
;;;;;	     RDYWaitF
	pop	ax
	mov	al, ah
	OutCommandF
;	call	TimeDelay
;;;;	    RDYWaitF
	loadport
	setport DataStrobe0
	in	al, dx
	push	ax
;;	  WDUMMY
	call	WDUMMY
;	call	TimeDelay
	pop	ax
IID22:
;;	  endm
	ret
IDC2INIT	endp


IF 0
public		CheckINTR
CheckINTR	proc	near
	cmp	_EBP NICMode, NIBBLEMODE
	jne	CIRet

	loadport
	setport StatusPort
	in	al, dx
	test	al, INTLEVEL
	jz	CIRet
	pushf
	cli					;disable interrupt
	setport StatusPort
	RDYWait 				;check ready
	setport CmdPort
	mov	al, 18h
	out	dx, al				;change to prn mode
	jmp	$+2
	jmp	$+2
	jmp	$+2
	mov	al, IRQEN+ICEN+DS0
	or	al, _EBP OutDirection
	out	dx, al				;enter NIC mode
	jmp	$+2
	jmp	$+2
	popf
CIRet:
	ret
CheckINTR	endp
ENDIF


; + modified by Peter Yu on 12/29/92 for MS WFW
IF NDIS_DOS_WKS_driver or ODI_DOS_WKS_driver or Packet_Driver or IPX_WKS_driver
;
; If the driver will be released from system, please call this function.
;
; Input : NONE
;
;	  Interrupt disable
;
;Output :
;	  ALL register and status will be save.
;
RestorePort	proc	near

	pushf
	cli

	push	es
	push	di
	push	ax

	xor	ax,ax
	mov	es,ax

	mov	di,Save_Printer
	mov	ax,Save_IOBase
	mov	es:[di],ax
	mov	di,411h
	mov	al,Save_EQUIP
	mov	byte ptr es:[di],al
	pop	ax
	pop	di
	pop	es

	popf

RestorePort	endp
ENDIF
;-

public CheckIRQEN
CheckIRQEN	proc	near
IFDEF ps
print p
ENDIF
	cmp	_EBP MPX_exist, 0
	jne	ChkIRQEN
	ret
ChkIRQEN:
	cmp	_EBP In_ISR,0
	jnz	do_nothing0
	push	ax
	push	dx
	mov	dx,_EBP io_addr 	; restore I/O base to DX
	add	dx,CmdPort		; set I/O port to CMD port
	in	al,dx
	test	al,IRQEN
	jnz	do_nothing

	inc	_EBP ticks
	cmp	_EBP ticks,6
	jb	do_nothing1

	in	al,dx			; read CMD port
	and	al,AUTOFEED+STROBE
	or	al,IRQEN+INITP
	mov	_EBP CmdValueSave,al	; save CMD port value
	out	dx,al

	and	al,not INITP
	out	dx,al

	sub	dx,CmdPort		; set I/O port to DATA port
	in	al,dx
	mov	_EBP DataValueSave,al

	mov	al,017h ;;;97h
	out	dx,al			; write 1st pattern
	mov	al,057h ;;;d7h
	out	dx,al

	mov	al,00bh ;;;8bh
	out	dx,al			; write 2nd pattern
	mov	al,04bh ;;;cbh
	out	dx,al

	mov	al,27h	;;;MPX_MODE1+MPX_CHECK_BIT  ; enable MPX interrupt function
	out	dx,al
	or	al,40h	;;;CLOCK
	out	dx,al
	or	al,80h	;;;CLEAR_MPX	; clear MPX pattern check squence
	out	dx,al

	mov	al,_EBP DataValueSave
	out	dx,al

	add	dx, CmdPort
	mov	al,_EBP CmdValueSave	   ; restore CMD port value
	and	al,not INITP
	out	dx,al
	or	al,INITP
	out	dx,al
IFDEF ps
print P
ENDIF
do_nothing:
	mov	_EBP ticks,0
do_nothing1:
	pop	dx
	pop	ax
do_nothing0:
	ret
CheckIRQEN	endp


IF	Server_386_driver
else
.8086
endif
