
;-------------------------------------------------------------------------
;   EnterReceive
;	Start remote read cycle, and set remote start address
;
;   Assumes
;	DS		DGroup
;	ax		zero --> first time to enter receive cycle in this ISR
;			non zero --> not the first time
;	bx		the packet offset to receive
;
;   Output
;	Cflag		set on means No Packet Receive
;	cx		data length of packet
;
;   Modified Registers
;	ax, bx, cx, dx, di, si, bp, es
;-------------------------------------------------------------------------
public	EnterReceive
EnterReceive	proc	near
IFDEF	ps
print C
ENDIF
	pushf
	cli
	mov	cx, bx

	call	NIC_Mode			;enter NIC mode
;;;	Mode_NIC

	call	BufferEmpty			;check rcv buffer ring empty
	jnc	ER1
	call	Prn_Mode
;;;	Mode_Prn
IFDEF	ps
print 1
ENDIF
	popf
	stc
	ret
ER1:
	cmp	_EBP StartPacketRx, DYES	;first time to receive this pack
	jne	NotFirstRx

	mov	cx, word ptr _EBP NextPage
;;	  cmp	  ch, prepage
;;	  jne	  ER2
;;	  jmp	  reset_dead_hardware
ER2:
	mov	_EBP prepage, ch		 ;new prepage
	jmp	short EnterRR

NotFirstRx:
	add	cx, 4				;add 4 byte header
	add	ch, _EBP prepage
;--------------
; 9/3/1992 Andge Chen			check round back
	cmp	ch, _EBP EPRRegister
	jbe	ER5
	sub	ch, _EBP EPRRegister
	dec	ch
	add	ch, _EBP SPRRegister
ER5:
;----------
;----------- Enter Remote Read Period --------------
EnterRR:
	mov	di, _EBP StartPacketRx		 ;save Flag for later used
	mov	_EBP StartPacketRx, InRR	 ;specify in RR Cycle

;IFDEF	 OLD
;	 mov	 al, RR
;ELSE
	mov	al, RRN 			;remote read
;	mov	al, RRA 			;remote read
;ENDIF

;----------------------
; 8/12/1992 Andge chen		enhance performance

	mov	bl, _EBP NICMode
	cmp	bl, NIBBLEMODE
	jne	ERCheckByte
	jmp	ERNibble
ERCheckByte:
	cmp	bl, BYTEMODE
	jne	ERFast
	jmp	ERByte
ERFast:
	call	WC1
	mov	al, ch
	call	WR11
	mov	al, cl
	call	WR01
	cmp	di, DYES
	je	ER4
	jmp	ERRet2
ER4:
	mov	cx, 4
	push	ds
	pop	es
IF	Server_386_driver
	lea	edi, _EBP HeaderBuffer
ELSE
	lea	di, HeaderBuffer
ENDIF
	call	RR1
	jmp	GotHeader

ERNibble:
	call	WC3
	mov	al, ch
	call	WR13
	mov	al, cl
	call	WR03
	jmp	ReadHeader

ERByte:
	call	WC3
	call	WD3
	mov	al, ch
	call	WR13
	call	WD3
	mov	al, cl
	call	WR03
ReadHeader:
	cmp	di, DYES
	jne	ERRet2
     ;	je	@F
     ;	jmp	ERRet2
;@@:
	mov	cx, 4
	push	ds
	pop	es
IF	Server_386_driver
	lea	edi, _EBP HeaderBuffer
ELSE
	lea	di, HeaderBuffer
ENDIF
;;;	call	NBTest				;remote read header
	call	GetRxData

GotHeader:



;;;	   WCR
;	 call	 WCR
;;----------- Set Remote Read Start Address ----------
;	 cmp	 NICMode, ByteMode
;	 je	 TT1
;	 jmp	 NoNeedDirChg
;TT1:
;;;	   WDUMMY
;	 call	 WDUMMY
;NoNeedDirChg:
;	 mov	 al, ch 			 ;RSA1 data
;;;	   WRSA1
;	 call	 WRSA1
;
;	 cmp	 NICMode, ByteMode
;	 je	 TT2
;	 jmp	 NoNeedDirChg1
;TT2:
;;;	   WDUMMY
;	 call	 WDUMMY
;
;NoNeedDirChg1:
;	 mov	 al, cl 			 ;RSA0 data
;;;	   WRSA0
;	 call	 WRSA0
;
;	 cmp	 di, DYES
;	 jne	 ERRet2
;
;	 mov	 cx, 4				 ;begin to receive a packet
;;	 push	 ds
;;	 pop	 es
;	 mov	 ax, ds
;	 mov	 es, ax
;	 lea	 edi, HeaderBuffer
;	 call	 GetRxData
;----------------------

IF	Server_386_driver
	mov	cl, es:[edi].Rx_NextPage
ELSE
	mov	cl, es:[di].Rx_NextPage
ENDIF
	cmp	cl, 0
	jne	NW1
IFDEF	ps
print Z
ENDIF
	jmp	short Page0Error
NW1:
	cmp	cl, _EBP EPRRegister
	jbe	NW2
IFDEF	ps
print A
ENDIF
	jmp	short Page0Error
NW2:
	cmp	cl, _EBP SPRRegister
	jnb	recv_rcv
IFDEF	ps
print B
ENDIF

public Page0Error
Page0Error:
IFDEF	ps
print G
ENDIF
	jmp	reset_dead_hardware
;--------------------------------------------------

recv_rcv:

IF	Server_386_driver
	mov	ax, es:[edi].Rx_ByteCount
ELSE
	mov	ax, es:[di].Rx_ByteCount
ENDIF
	add	ax, 4-1+100h		     ;4 bytes is crc field after packet
	add	ah, _EBP Next_Page
	cmp	ah, _EBP EPRRegister
	jbe	NoOverFlow
	sub	ah, _EBP EPRRegister
	dec	ah
	add	ah, _EBP SPRRegister
NoOverFlow:
IF	Server_386_driver
	cmp	ah, es:[edi].Rx_NextPage
ELSE
	cmp	ah, es:[di].Rx_NextPage
ENDIF
	je	NW3
IFDEF	ps
print E
ENDIF
	jmp	short Page0Error
NW3:
	mov	_EBP Next_Page, ah
;	 mov	 ah, es:[di].Rx_nextPage
;	 mov	 _EBP Next_Page, ah

ERRet:
IF	Server_386_driver
	mov	cx, es:[edi].Rx_ByteCount
ELSE
	mov	cx, es:[di].Rx_ByteCount
ENDIF
	sub	cx, 4				;decrement 4 byte header
	cmp	cx, RUNT
	jb	LengthError
	cmp	cx, GIANT
	ja	LengthError
ERRet2:
	popf
	clc
	ret

LengthError:
IFDEF	ps
print u
ENDIF
	mov	ax, -1				;exit RR
	call	ExitReceive
	popf
	stc
	ret

reset_dead_hardware:
IFDEF	ps
print r
ENDIF
	mov	_EBP StartPacketRx, DYES

;;	  WDUMMY
	call	WDUMMY

	call	NICInitial
	cmp	_EBP CurrTx, 0
	jne	NW4
	call	Prn_Mode
;;;	Mode_Prn
	popf
	stc
	ret
NW4:
	call	StartTxAgain			;have Tx packet pending
	call	Prn_Mode
;;;	Mode_Prn
	popf
	stc
	ret
EnterReceive	endp



;-------------------------------------------------------------------------
;   GetRxData
;	Remote read data which follows the last remote read
;
;   Assume
;	Already in remote read cycle
;	DS		DGroup
;	es:di		buffer pointer to save the received data
;	cx		length to received
;
;   Output
;
;   Modified Registers
;	ax, bx, cx, si, dx, di
;-------------------------------------------------------------------------
;public  GetRxData
;GetRxData	 proc	 near
;print d
;	 call	 RemoteRead
;	 ret
;GetRxData	 endp


;-------------------------------------------------------------------------
;   ExitReceive
;	Exit remote read cycle, this routine has two mode -- temporary and
;	really. The temporarily exit means the data is not received
;	completely. It will enter remote read cycle again to complete the
;	packet reception.
;	The really exit mode will advance next page register.
;
;   Assumes
;	DS		DGroup
;	ax		zero -->temporary exit
;			non zero --> really exit this packet reception
;
;   Output
;
;   Modified Registers
;	ax, bx, cx, dx, di, si, bp
;-------------------------------------------------------------------------
public	ExitReceive
ExitReceive	proc	near
IFDEF	ps
print c
ENDIF
	pushf
	cli

	mov	cx, ax				;save ax
;;	  WDUMMY				  ;dummy command to exit RR
;	call	WDUMMY
	test	_EBP NICMode, FASTMODE
	jz	EC2
	jmp	EC1
EC2:
	mov	bh, _EBP NIC_Cmd

	loadport
	setport StatusPort
	RDYWait

	setport CmdPort
	mov	al, bh
	out	dx, al				;set prn port to out direction

	mov	al, W_DUMMY
	setport DataPort
;;;	OutCommand
	out	dx, al
	setport CmdPort
	mov	al, bh
	xor	al, CS0
	out	dx, al

	setport StatusPort
	RDYWait

	setport CmdPort
	mov	al, bh
	out	dx, al

	or	cx, cx
	jnz	XR1
	mov	_EBP StartPacketRx, DNO
	jmp	ExitRet
XR1:
	loadport
	setport StatusPort
	RDYWait

	mov	al, W_NPRF
	setport DataPort
;	OutCommand
	out	dx, al
	setport CmdPort
	mov	al, bh
	xor	al, CS0
	out	dx, al
	setport StatusPort
	RDYWait
	mov	al, _EBP Next_Page
;;	OutData
	setport DataPort
	out	dx, al
	setport CmdPort
	xor	bh, DS0 or DS1
	mov	al, bh
	out	dx, al
	mov	_EBP NIC_Cmd, bh
	jmp	XD2
EC1:
	mov	al, W_DUMMY
	OutCommandF
	or	cx, cx
	jnz	XR11
	mov	_EBP StartPacketRx, DNO
	jmp	ExitRet
XR11:
	mov	al, W_NPRF
	OutCommandF
	mov	al, _EBP Next_Page
	setport DataStrobe0
	out	dx, al
XD2:
;;;;;;;;;;;;
	mov	_EBP StartPacketRx, DYES
ExitRet:
	call	Prn_Mode			;return to printer mode
;;;	Mode_Prn
	popf
	ret
ExitReceive	endp


