

;-------------------------------------------------------------------------
;
;      DSend
;
;      On Entry:
;	       ES:SI points to a fully prepared HwLibSCB
;	       DS shall be set
;	       Interrupts are DISABLED but may be reenabled temporarily
;		 if necessary
;
;		HwLibSCB	struc
;		SCB_ECB_off	     dw      ?
;		SCB_ECB_seg	     dw      ?
;		SCB_Fragment_off     dw      ?
;		SCB_Fragment_seg     dw      ?
;		SCB_Fragment_count   dw      ?
;		SCB_Header_off	     dw      ?
;		SCB_Header_seg	     dw      ?
;		SCB_Header_len	     dw      ?
;		HwLibSCB	ends
;
;      On Exit:
;	       Carry flag set : No Tx buffer
;	       Carry flag reset : Tx successfully
;	       No registers or flags need to be saved
;
;      Modified Registers :
;	       AX,BX,CX,DX,DI,SI,ES
;
;-------------------------------------------------------------------------
public	DSend

OutOFResource:
IFDEF	ps
print O
ENDIF
	popf
;	clc		;12/4/1992 Andge Chen
	stc
	ret

OutOFResource1:
WaitLoop:					;****** Can not Used *****
	call	GetTxStatus			;when BNC and connectionless
	jnz	TxComplete			;the TXBZ0,1 always high will
	jmp	$+2				;cause infinite loop
	jmp	$+2				;***********
	jmp	WaitLoop
TxComplete:
	call	ProcessTxEvent
	jmp	DSAgain


DSend	proc	near
IFDEF	ps
print S
ENDIF
	pushf
	cli

DSAgain:
	cmp	_EBP StartPacketRx, InRR
	je	OutOFResource			;in RR Cycle

	cmp	_EBP DisableTx, DYES
	je	OutOFResource

	test	_EBP TxFlag, TXBF0		 ;check xmit buffer empty
	jnz	CheckNext
IFDEF	ps
print W
ENDIF
IF	Server_386_driver
	or	_EBP TxFlag, TXBF0
	lea	edi, _EBP Tx0Struct
	mov	_EBP CurrWrite, edi
	mov	eax, es:[esi].SCB_ECB_off
	mov	ds:[edi].TCB_off, eax
	mov	ax, es:[esi].SCB_ECB_seg
	mov	ds:[edi].TCB_seg, ax
	mov	_EBP cmd_value, RW0		 ;remote write buffer 0
	jmp	GotBuffer
ELSE
	or	TxFlag, TXBF0
	lea	di, Tx0Struct
	mov	word ptr CurrWrite, di
	mov	ax, es:[si].SCB_ECB_off
	mov	ds:[di].TCB_off, ax
	mov	ax, es:[si].SCB_ECB_seg
	mov	ds:[di].TCB_seg, ax
	mov	cmd_value, RW0		    ;remote write buffer 0
	jmp	GotBuffer
ENDIF
CheckNext:
	test	_EBP TxFlag, TXBF1		 ;check tx buffer 1
	jnz	OutOFResource
IFDEF	ps
print w
ENDIF
IF	Server_386_driver
	or	_EBP TxFlag, TXBF1
	mov	_EBP cmd_value, RW1
	lea	edi, _EBP Tx1Struct
	mov	_EBP CurrWrite, edi
	mov	eax, es:[esi].SCB_ECB_off
	mov	ds:[edi].TCB_off, eax
	mov	ax, es:[esi].SCB_ECB_seg
	mov	ds:[edi].TCB_seg, ax
ELSE
	or	TxFlag, TXBF1
	mov	cmd_value, RW1
	lea	di, Tx1Struct
	mov	word ptr CurrWrite, di
	mov	ax, es:[si].SCB_ECB_off
	mov	ds:[di].TCB_off, ax
	mov	ax, es:[si].SCB_ECB_seg
	mov	ds:[di].TCB_seg, ax
ENDIF

GotBuffer:
;----------- Enter NIC Mode -----------
;CounterINC	 0
	call	NIC_Mode
;;;	Mode_NIC

;----------- Enter Remote Write Period -----------
XmitAgain:
;	call	WCR

	test	_EBP NICMode, FASTMODE
	jz	TxWCRNB
;	OutCommandF
	loadport
	mov	al, _EBP cmd_value		 ;remote write buffer
	or	al, W_CR
	add	dx, AddrStrobe
	out	dx, al
	jmp	RWStart
TxWCRNB:
	loadport
	setport StatusPort
	RDYWait

;	OutCommand
	mov	al, _EBP cmd_value		 ;remote write buffer
	or	al, W_CR
	setport DataPort
;	dec	dx
	out	dx, al
	mov	bl, _EBP NIC_Cmd
	mov	al, bl
	xor	al, CS0
;	or	al, _EBP OutDirection
	setport CmdPort
;	add	dx, 2
	out	dx, al
	setport StatusPort
;	dec	dx
	RDYWait
	setport CmdPort
;	inc	dx
	mov	al, bl
;	or	al, _EBP OutDirection
	out	dx, al
;;;;;;;;;;;;;
;----------- Remote Write Immediately Data -----------
RWStart:
	mov	_EBP RemoteByteCount, 0
	mov	_EBP FirstFrag, 0

IF	Server_386_driver
	xor	ecx, ecx
	mov	cx, es:[esi].SCB_Header_len	 ;header length
;;;	   jcxz    FragmentData 		   ;no header
	or	cx, cx
	jz	FragmentData
	add	_EBP RemoteByteCount, cx
	push	es				;save
	push	esi
	mov	ax, es:[esi].SCB_Header_seg	 ;get header pointer
	mov	esi, es:[esi].SCB_Header_off
	mov	es, ax
ELSE
	mov	cx, es:[si].SCB_Header_len	;header length
	jcxz	FragmentData			;no header
	add	RemoteByteCount, cx
	push	es				;save
	push	si
	mov	ax, es:[si].SCB_Header_seg	;get header pointer
	mov	si, es:[si].SCB_Header_off
	mov	es, ax
ENDIF
;mov	 FirstFrag, 1
;call	 AOFSCheck
;mov	 al, cmd_value		     ;remote write buffer
;call	 WCR
	call	RemoteWrite			;remote write
IF	Server_386_driver
	pop	esi
	pop	es
ELSE
	pop	si
	pop	es
ENDIF

;---------- Remote Write Fragment data ---------------
FragmentData:
IF	Server_386_driver
	mov	di, es:[esi].SCB_Fragment_count  ;get fragment count
	or	di, di
	jz	RWEnd
	mov	ax, es:[esi].SCB_Fragment_seg
	mov	esi, es:[esi].SCB_Fragment_off	  ;fragment chain
	mov	es, ax
FragLoop:
	xor	ecx, ecx
;@@@@@@@
	mov	ecx, es:[esi].Frag_length
	jcxz	NextFrag
	add	_EBP RemoteByteCount, cx
	push	es
	push	esi
; by ted tai, no segment
;;;	mov	es, es:[esi].Frag_addr_seg
	mov	esi, es:[esi].Frag_addr_off
;cmp	 FirstFrag, 0
;jne	 NotFirst
;mov	 FirstFrag, 1
;call	 AOFSCheck
;mov	 al, cmd_value		     ;remote write buffer
;call	 WCR
;NotFirst:
	push	edi
	call	RemoteWrite			;remote write
	pop	edi
	pop	esi
	pop	es
NextFrag:
	add	esi, size AFrag 		 ;next fragment
	dec	di
	jnz	FragLoop
ELSE
	mov	di, es:[si].SCB_Fragment_count	;get fragment count
	or	di, di
	jz	RWEnd
	mov	ax, es:[si].SCB_Fragment_seg
	mov	si, es:[si].SCB_Fragment_off	;fragment chain
	mov	es, ax
FragLoop:
	mov	cx, es:[si].Frag_length
	jcxz	NextFrag
	add	RemoteByteCount, cx
	mov	ax, es:[si].Frag_addr_seg
	mov	bx, es:[si].Frag_addr_off
IF	NDIS_OS2_WKS_driver or ODI_OS2_WKS_driver
	push	cx
	call	FragmentToVirtual		;turn to virtual address
	pop	cx
ENDIF
	push	es
	push	si
	mov	es, ax
	mov	si, bx
;cmp	 FirstFrag, 0
;jne	 NotFirst
;mov	 FirstFrag, 1
;call	 AOFSCheck
;mov	 al, cmd_value		     ;remote write buffer
;call	 WCR
;NotFirst:
	push	di
	call	RemoteWrite			;remote write
	pop	di
	pop	si
	pop	es
NextFrag:
	add	si, size AFrag			;next fragment
	dec	di
	jnz	FragLoop
ENDIF

RWEnd:
	mov	ax, _EBP RemoteByteCount
	cmp	ax, RUNT
	jae	LGood1
	mov	ax, RUNT
LGood1:
IF	Server_386_driver
	mov	edi, _EBP CurrWrite
	mov	ds:[edi].TxByteCount, ax
ELSE
	mov	di, word ptr CurrWrite
	mov	ds:[di].TxByteCount, ax
ENDIF

;;;;IF	    IPX_WKS_driver or ODI_DOS_WKS_driver
	test	al, 1
	jz	EvenByte
	mov	cx, 1
	push	di
	call	RemoteWrite
	pop	di
EvenByte:
;;;;ENDIF

	cmp	_EBP TxBusy, 0
	jnz	TT3
	jmp	TxNow
TT3:
;------------ Exit Remote Write Period ------------
	inc	_EBP TxWait
IF	Server_386_driver
	mov	ds:[edi].UseFlag, 1		 ;wait
ELSE
	mov	ds:[di].UseFlag, 1		;wait
ENDIF
						;remote write and start Txmit
;;	  WDUMMY				  ;issue a dummy command to exit
	call	WDUMMY

	jmp	DSendRet
TxNow:
;------------
; 6/24/1992 Andge
;;;	   xchg    al, ah
;;;	   call    WTBR
;---------------

;;	  WDUMMY				  ;issue a dummy command to exit
	call	WDUMMY

	IncErrorCounter TOTALTXPACKETCOUNT	;increment transmit counter

	mov	_EBP CurrTx, TXBF0
	cmp	_EBP cmd_value, RW0
	jz	DSND1
	mov	_EBP CurrTx, TXBF1
DSND1:
	inc	_EBP TxBusy			 ;set TxBusy flag
IF	Server_386_driver
	mov	ds:[edi].UseFlag, 2		 ;xmit now
	call	GetTick 			;get current tick
	mov	ds:[edi].Tick, ax
ELSE
	mov	ds:[di].UseFlag, 2		;xmit now
	call	GetTick 			;get current tick
	mov	ds:[di].Tick, ax
ENDIF

;;;	mov	al, TXEN
;;;;;	     WCR
;;;	call	WCR
;;;	mov	al, 0
;;;;;	     WCR
;;;	call	WCR

;-------------------
; 6/19/1992 Andge chen
;	 loadport
;	 setport StatusPort
;iii:
;	 in	 al, dx
;	 test	 al, CurrTx
;	 jnz	 iii
;;;;	call	ProcessTxEvent
;------------------------
;------------ Return to Printer Mode -----------
DSendRet:
	call	Prn_Mode
;;;	Mode_Prn
	popf
	clc
	ret
DSend	endp



;-------------------------------------------------------------------------
;   GetTxStatus
;
;   Description :
;      The routine will return the status of tx event
;
;   Assume :
;      DS shall be set
;
;   Return :
;      Zero flag set   : No Tx Event occurs
;      Zero flag reset : Tx event needs be processed
;
;   Modified Registers :
;      AX,CX,DX,BP
;
;-------------------------------------------------------------------------
public	GetTxStatus
GetTxStatus	proc	near
IFDEF	ps
print T
ENDIF
	cmp	_EBP CurrTx, 0			     ;has packet transmitting
	jnz	GTS1
	ret
GTS1:
;-------------
; 11/14/1992 Andge Chen   For BNC T16
	cmp	_EBP T16Flag, DYES
	jne	NotT16
	mov	_EBP T16Flag, DNO
	or	ax, 0ffh
	ret
NotT16:
;----------
	call	NIC_Mode			;enter NIC Mode
;;;	Mode_NIC

	loadport
	setport StatusPort
	in	al, dx

	test	al, _EBP CurrTx 		 ;test transmit busy
	jnz	GTS2
	call	Prn_Mode			;return to print mode
;;;	Mode_Prn
	or	ax, 0ffh			;xmit complete
	ret
GTS2:
	call	Prn_Mode			;return to print mode
;;;	Mode_Prn
	xor	ax, ax				;not complete
	ret
GetTxStatus	endp



;-------------------------------------------------------------------------
;   ProcessTxEvent
;
;   Description:
;	This routine is called to process the transmit event
;
;   Assumes:
;	DS shall be set
;
;   Returns:
;	AX = ProcessTxSuccessfulReturn
;			  Transmit successful (or failed)
;			     ES:SI point to ECB
;
;	AX = ProcessTxRetryReturn
;			: Transmit error and has retransmited
;
;	AX = ProcessTxCanceledReturn
;			: Transmit was canceled
;
;
;   Modified registers :
;	AX,BX,CX,DX,DI,SI,BP,ES
;
;-------------------------------------------------------------------------
public	ProcessTxEvent
ProcessTxEvent	proc	near
IFDEF	ps
print t
ENDIF
IF	Server_386_driver
	lea	edi, _EBP Tx0Struct
	cmp	_EBP CurrTx, TXBF0
	jz	PTE1
	lea	edi, _EBP Tx1Struct
PTE1:
	mov	ax, ProcessTxSuccessfulReturn
	cmp	ds:[edi].UseFlag, 3		 ;Canceled
ELSE
	lea	di, Tx0Struct
	cmp	CurrTx, TXBF0
	jz	PTE1
	lea	di, Tx1Struct
PTE1:
	mov	ax, ProcessTxSuccessfulReturn
	cmp	ds:[di].UseFlag, 3		;Canceled
ENDIF
	jne	PTE2
	mov	ax, ProcessTxCanceledReturn
PTE2:
	push	ax
IF	Server_386_driver
	mov	ax, ds:[edi].TCB_seg
	mov	es, ax
	mov	esi, ds:[edi].TCB_off		  ;es:si --> ECB
	mov	ds:[edi].UseFlag, 0
ELSE
	mov	ax, ds:[di].TCB_seg
	mov	es, ax
	mov	si, ds:[di].TCB_off		;es:si --> ECB
	mov	ds:[di].UseFlag, 0
ENDIF

	mov	al, _EBP CurrTx
	xor	_EBP TxFlag, al 		 ;clear xmit buffer flag

	cmp	_EBP TxWait, 0
	jne	NextTx

	mov	_EBP TxBusy, 0			 ;clear xmit busy flag
	mov	_EBP CurrTx, 0
	jmp	PTERet

NextTx:
IFDEF	ps
print p
ENDIF
	IncErrorCounter TOTALTXPACKETCOUNT	;increment transmit counter

	mov	_EBP TxWait, 0			 ;clear TxWait flag
	xor	_EBP CurrTx, TXBF0+TXBF1	 ;set current xmit buffer

;;;	call	NIC_Mode

IF	Server_386_driver
	lea	edi, _EBP Tx0Struct
	mov	al, RW0
	cmp	_EBP CurrTx, TXBF0
	jz	NW5
	lea	edi, _EBP Tx1Struct
	mov	al, RW1
NW5:
	mov	ds:[edi].UseFlag, 2		 ;xmit now
	call	GetTick 			;get current tick
	mov	ds:[edi].Tick, ax
ELSE
	lea	di, Tx0Struct
	mov	al, RW0
	cmp	CurrTx, TXBF0
	jz	@F
	lea	di, Tx1Struct
	mov	al, RW1
@@:
	mov	ds:[di].UseFlag, 2		;xmit now
	call	GetTick 			;get current tick
	mov	ds:[di].Tick, ax
ENDIF
PTERet:
	pop	ax				;restore return code
	ret
ProcessTxEvent	endp



;-------------------------------------------------------------------------
;  QueryInTx
;
;  Description :
;	This routine will response the NIC is transmitting or not
;
;  Assume :
;	DS shall be set
;
;  Return :
;	Zero flag set	: not in Tx
;	Zero flag reset : in Tx
;
;  Modified Registers :
;	None
;-------------------------------------------------------------------------
public	QueryInTx
QueryInTx	proc	near
	cmp	_EBP CurrTx, 0
	ret
QueryInTx	endp


;-------------------------------------------------------------------------
;   QueryTxTimeOut
;	This routine will response current Tx Packet time out or not
;
;   Input
;	DS		DGroup
;	Tx must be in processing( by QueryInTx )
;
;   Output
;	Cflag		set on means timeout
;			es:si point to ECB
;
;   Modified Register
;	All
;-------------------------------------------------------------------------
public	QueryTxTimeOut
QueryTxTimeOut	proc	near

	pushf
	cli
	cmp	_EBP CurrTx, 0			     ;check current Tx packet
	jz	QTORet

IF	Server_386_driver
	lea	edi, _EBP Tx0Struct		      ;find current TX structure
	cmp	_EBP CurrTx, TXBF0
	jz	QTO1
	lea	edi, _EBP Tx1Struct
QTO1:
	call	GetTick 			;get current tick
	sub	ax, ds:[edi].Tick		 ;
ELSE
	lea	di, Tx0Struct			;find current TX structure
	cmp	CurrTx, TXBF0
	jz	QTO1
	lea	di, Tx1Struct
QTO1:
	call	GetTick 			;get current tick
	sub	ax, ds:[di].Tick		;
ENDIF
	cmp	ax, TxTimeOutCount		;check timeout
	ja	ProcessTimeOut
QTORet:
	popf
	clc
	ret

ProcessTimeOut:
IF	Server_386_driver
	push	edi
ELSE
	push	di
ENDIF
	IncErrorCounter PACKETTXTIMEOUT

	call	NIC_Mode
;;;	Mode_NIC
	call	NICInitial			;hardware reset
IF	Server_386_driver
	pop	edi

	mov	ds:[edi].UseFlag, 0
	mov	ax, ds:[edi].TCB_seg
	mov	es, ax
	mov	esi, ds:[edi].TCB_off		  ;es:si --> ECB
ELSE
	pop	di

	mov	ds:[di].UseFlag, 0
	mov	ax, ds:[di].TCB_seg
	mov	es, ax
	mov	si, ds:[di].TCB_off		;es:si --> ECB
ENDIF

	cmp	_EBP TxWait, 0
	jne	QTO2
	mov	_EBP TxBusy, 0			 ;clear xmit busy flag
	mov	_EBP CurrTx, 0
	mov	_EBP TxFlag, 0			     ;For DSend
	call	Prn_Mode
;;;	Mode_Prn
	popf
	stc
	ret
QTO2:
	IncErrorCounter TOTALTXPACKETCOUNT	;increment transmit counter

	mov	_EBP TxWait, 0			     ;clear TxWait flag
	mov	al, _EBP CurrTx
	xor	_EBP TxFlag, al 		     ;set used buffer
	xor	_EBP CurrTx, TXBF0+TXBF1	     ;set current xmit buffer

	call	StartTxAgain			;start Tx again

	call	Prn_Mode
;;;	Mode_Prn
	popf
	stc
	ret
QueryTxTimeOut	endp


;-------------------------------------------------------------------------
;   StartTxAgain
;	After Adapter reset, the pending xmit packet is start again
;
;   Input
;	Already in NIC Mode
;
;   Modified Registers
;	ax. bx, dx, di
;-------------------------------------------------------------------------
public StartTxAgain
StartTxAgain	proc	near
IFDEF	ps
print J
ENDIF
IF	Server_386_driver
	lea	edi, _EBP Tx0Struct
ELSE
	lea	di, Tx0Struct
ENDIF
	mov	al, RW0
	cmp	_EBP CurrTx, TXBF0
	je	ST1
IF	Server_386_driver
	lea	edi, _EBP Tx1Struct
ELSE
	lea	di, Tx1Struct
ENDIF
	mov	al, RW1
ST1:
IF	Server_386_driver
	mov	ds:[edi].UseFlag, 2		 ;xmit now
ELSE
	mov	ds:[di].UseFlag, 2		;xmit now
ENDIF
;----------- Enter Remote Write Period -----------
;;	  WCR
	call	WCR

;----------- Set transmit byte count -------------
IF	Server_386_driver
	mov	ax, ds:[edi].TxByteCount
ELSE
	mov	ax, ds:[di].TxByteCount
ENDIF
	xchg	ah, al
;;	  WTBR
	call	WTBR
;----------- Transmit Enable -----------
;	 mov	 al, TXEN			 ;next packet
;;;	   WCR
;	 call	 WCR
;	 mov	 al, 0
;;;	   WCR
;	 call	 WCR
	call	WDUMMY				;ending Remote write

	call	GetTick 			;get current tick
IF	Server_386_driver
	mov	ds:[edi].Tick, ax
ELSE
	mov	ds:[di].Tick, ax
ENDIF

	cmp	_EBP TxWait, 0
	jne	ST2
	ret
ST2:
IF	Server_386_driver
	lea	edi, _EBP Tx0Struct
	mov	al, RW0
	cmp	_EBP CurrTx, TXBF0
	jne	ST3
	lea	edi, _EBP Tx1Struct
	mov	al, RW1
ELSE
	lea	di, Tx0Struct
	mov	al, RW0
	cmp	CurrTx, TXBF0
	jne	ST3
	lea	di, Tx1Struct
	mov	al, RW1
ENDIF
ST3:
;----------- Enter Remote Write Period -----------
;;	  WCR
	call	WCR

;----------- Set transmit byte count -------------
IF	Server_386_driver
	mov	ax, ds:[edi].TxByteCount
ELSE
	mov	ax, ds:[di].TxByteCount
ENDIF
	xchg	ah, al
;;	  WTBR
	call	WTBR
;----------- Exit Remote Write ------------
;;	  WDUMMY
	call	WDUMMY
	ret
StartTxAgain	endp




;-------------------------------------------------------------------------
;   TxAPacket
;	Transmit a packet if there is not any sending packet
;
;   Input
;	DS		DGroup
;
;-------------------------------------------------------------------------
public	TxAPacket
TxAPacket	proc	near
	ret
TxAPacket	endp


AOFSCheck	proc	near
	mov	ax, di
	mov	bx, si
	mov	dx, cx

	xchg	di,si
	add	si, Address
	mov	cx, 6
	rep	cmpsw
	mov	cx, dx
	mov	si, bx
	mov	di, ax
	je	AC1

	push	es
	push	ds

	push	es
	pop	ds
	pop	es
	push	es
	add	di, Address
	mov	cx, 6
	rep	movsw
	pop	ds
	pop	es
	mov	cx, dx
	mov	si, bx
	mov	di, ax
	test	_EBP SCRRegister, AUTOFFSET
	jz	ACRet
	xor	_EBP SCRRegister, AUTOFFSET
	jmp	short SetSCR
AC1:
	sub	cx, 12
	sub	si, 12
	test	_EBP SCRRegister, AUTOFFSET
	jnz	ACRet
	or	_EBP SCRRegister, AUTOFFSET
SetSCR:
	mov	al, _EBP SCRRegister
	mov	ah, W_SCR
	call	IDC1
ACRet:
	ret
AOFSCheck	endp
